# Copyright 2014 - 2019 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

list_categories() {
  grep -vxE '^[ 	]*$' "${_DATA}/mappings/categories"
}

w_filter_item() {
n=$3
cat <<EOF
  [fieldset .item
    [legend $(l10n filter_item):]

    $(for field in any name street zip TEL BDAY CATEGORIES; do
      printf '[input id="%s%i" type="radio" name="filter_type%i" value="%s" %s]
              [label for="%s%i" %s ]' \
              "$field" "$n" "$n" "$field" "$([ "$1" = "$field" ] && printf checked )" \
              "$field" "$n" "$(l10n filter_$field)"
    done)
    [input type="text" name="filter_text$n" value="$([ "$1" = CATEGORIES ] || HTML "$2")" placeholder="$(l10n filter_placeholder)"]
    [fieldset .categories
      $(list_categories | while read cat; do
          printf '[label [checkbox "filter_cat%i" "|%s" %s] %s ]' \
                 "$n" "$(HTML "$cat")" \
                 "$(printf %s "$cat" |grep -qxEe "$2" && printf checked )" \
                 "$(HTML "$cat")"
      done)
      [a href="/cards/categories.sh" $(l10n edit_categories)]
    ]
  ]
EOF
}

w_filter_diag(){
  cat <<EOF
  [form .filter action="/cards/filter_card.sh" method="POST"
    [h1 $(l10n filter_label)]
    [input type="hidden" name="page" value="cards"]
  
    $(n=0; filter="${filter}^"
      while [ "${filter#^}" ]; do
        fil="${filter%%^*}" filter="${filter#*^}"
        w_filter_item "${fil%%:*}" "${fil#*:}" $n
        n=$((n + 1))
      done
      w_filter_item any '' $n
    )
  
    [fieldset class="order"
      [legend $(l10n filter_order):]
      [label [radio "order" "firstname" $( [ "$order" = firstname ] && printf checked )] $(l10n filter_firstname)]
      [label [radio "order" "lastname"  $( [ "$order" = lastname  ] && printf checked )] $(l10n filter_lastname)]
      [label [radio "order" "bdate"     $( [ "$order" = bdate     ] && printf checked )] $(l10n filter_bdate)]
    ]
    [button type="submit" name="choice" value="new_filter" $(l10n filter_apply)]
    [button type="submit" name="choice" value="del_filter" $(l10n filter_cancel)]
  ]
EOF
}

# listcards |grep ${edit:+-v} "$edit" \
# | while read card; do
#   "${_EXEC}"/cgilite/html-sh.sed <<-ENDCARD
# 	[div #${card} .card
# 	  $(view_card "$card")[!--
# 	  --][div .control
# 	    [a "?action=edit_card&card=${card}" .item $(l10n edit)]
# 	    [a "?action=export_vcard&card=${card}".item $(l10n vcf_export)]
# 	    ${profile_medical:+[a "?action=new_prescription&client=${card}" .item $(l10n new_prescription)]}
# 	]]
# 	ENDCARD
# done

